// 2010-11-08 programmeerimisvõistlus
// Ülesanne: MULTI-ANT
// Autor: Ahto Truu
// Testitud: GCC 3.4.5 / Win32

#include <fstream>
#include <sstream>
#include <string>
#include <map>
#include <set>
using namespace std;

ifstream sisf("s1sis.txt");
ofstream valf("s1val.txt");

typedef set<string> sset;

// sammu andmed
struct samm {
    int e; // eelduste arv
    sset s; // temast sõltuvad
    int t; // tegemise aeg
};

int n;
map<string, samm> a; // samm -> tema andmed

int main() {
    // loeme sisendandmed
    sisf >> n >> ws; // loeme n ja sellele järgneva reavahetuse
    for (int i = 0; i < n; ++i) {
        string s, s1, s2;
        getline(sisf, s); // loeme ühe sammu andmed
        stringstream ss(s);
        ss >> s1; // eraldame sammu enda nime
        a[s1].e = 0;
        while (ss >> s2) { // eraldame sammu eeldused
            ++a[s1].e;
            a[s2].s.insert(s1);
        }
        a[s1].t = -1; // samm on veel tegemata
    }

    // lahendame ajaühikute kaupa simuleerides
    int t = 0;
    while (n > 0) { // kuni on veel tegemata samme
        // kogume veel tegemata sammud, millel puuduvaid eeldusi pole
        sset s;
        for (map<string, samm>::iterator i = a.begin(); i != a.end(); ++i) {
            if (i->second.e == 0 && i->second.t < 0) {
                s.insert(i->first);
            }
        }
        // märgime leitud sammud tegemisele
        for (sset::iterator i = s.begin(); i != s.end(); ++i) {
            a[*i].t = t; // märgime sammu tegemise aja
            // käime läbi kõik temast sõltuvad
            for (sset::iterator j = a[*i].s.begin(); j != a[*i].s.end(); ++j) {
                --a[*j].e; // vähendame puuduvate eelduste loendurit
            }
            --n; // vähendame tegemata sammmude arvu
        }
        ++t; // järgmine ajaühik
    }

    // väljastame tulemuse
    valf << t << endl;
    for (int i = 0; i < t; ++i) {
        bool e = true;
        for (map<string, samm>::iterator j = a.begin(); j != a.end(); ++j) {
            if (j->second.t == i) {
                if (!e) {
                    valf << " ";
                }
                valf << j->first;
                e = false;
            }
        }
        valf << endl;
    }

    return 0;
}
