// 2010-11-08 programmeerimisvõistlus
// Ülesanne: MULTI-ANT
// Autor: Ahto Truu
// Testitud: GCC 3.4.5 / Win32

#include <fstream>
#include <sstream>
#include <string>
#include <map>
#include <set>
#include <queue>
using namespace std;

ifstream sisf("s1sis.txt");
ofstream valf("s1val.txt");

typedef set<string> sset;

// sammu andmed
struct samm {
    int e; // eelduste arv
    sset s; // temast sõltuvad
    int t; // tegemise aeg
};

int n;
map<string, samm> a; // samm -> tema andmed
map<int, sset> t; // aeg -> sammud

int main() {
    // loeme sisendandmed
    sisf >> n >> ws; // loeme n ja sellele järgneva reavahetuse
    for (int i = 0; i < n; ++i) {
        string s, s1, s2;
        getline(sisf, s); // loeme ühe sammu andmed
        stringstream ss(s);
        ss >> s1; // eraldame sammu enda nime
        a[s1].e = 0;
        while (ss >> s2) { // eraldame sammu eeldused
            ++a[s1].e;
            a[s2].s.insert(s1);
        }
    }

    // algväärtustame järjekorra sammudega, millel eeldusi pole
    queue<string> q;
    for (map<string, samm>::iterator i = a.begin(); i != a.end(); ++i) {
        if (i->second.e == 0) {
            i->second.t = 0;
            q.push(i->first);
        }
    }
    // leiame ülejäänud sammude ajad modifitseeritud laiuti läbimisega
    while (!q.empty()) {
        string s = q.front(); q.pop();
        // käime läbi kõik temast sõltuvad
        for (sset::iterator i = a[s].s.begin(); i != a[s].s.end(); ++i) {
            --a[*i].e; // vähendame puuduvate eelduste loendurit
            if (a[*i].e == 0) {
                // kui kõik eeldused olemas, märgime tegemisele
                a[*i].t = a[s].t + 1;
                q.push(*i);
            }
        }
    }

    // kogume sammud nende tegemise aegade kaupa
    for (map<string, samm>::iterator i = a.begin(); i != a.end(); ++i) {
        t[i->second.t].insert(i->first);
    }

    // väljastame tulemuse
    valf << t.size() << endl;
    for (map<int, sset>::iterator i = t.begin(); i != t.end(); ++i) {
        for (sset::iterator j = i->second.begin(); j != i->second.end(); ++j) {
            if (j != i->second.begin()) {
                valf << " ";
            }
            valf << *j;
        }
        valf << endl;
    }

    return 0;
}
