// 2010-11-08 programmeerimisvõistlus
// Ülesanne: MULTI-ANT
// Autor: Ahto Truu
// Testitud: GCC 3.4.5 / Win32

#include <fstream>
#include <sstream>
#include <string>
#include <map>
#include <set>
using namespace std;

ifstream sisf("s1sis.txt");
ofstream valf("s1val.txt");

typedef set<string> sset;

int n;
map<string, sset> e; // samm -> eeldused
map<int, sset> t; // aeg -> sammud

// leiab sammu s tegemise varaseima võimaliku aja
int leia_aeg(const string &s) {
    // leiame kõige hiljem tehtava eelduse
    int k = 0;
    for (sset::iterator j = e[s].begin(); j != e[s].end(); ++j) {
        k = max(k, leia_aeg(*j));
    }
    // sammu enda saab teha alles pärast viimasena tehtavat eeldust
    return k + 1;
}

int main() {
    // loeme sisendandmed
    sisf >> n >> ws;
    for (int i = 0; i < n; ++i) {
        string s, s1, s2;
        getline(sisf, s);
        stringstream ss(s);
        ss >> s1; e[s1] = sset();
        while (ss >> s2) {
            e[s1].insert(s2);
        }
    }

    // lahendame sügavuti läbimisega ja kogume sammud tegemise aegade kaupa
    for (map<string, sset>::iterator i = e.begin(); i != e.end(); ++i) {
        t[leia_aeg(i->first)].insert(i->first);
    }

    // väljastame tulemuse
    valf << t.size() << endl;
    for (map<int, sset>::iterator i = t.begin(); i != t.end(); ++i) {
        for (sset::iterator j = i->second.begin(); j != i->second.end(); ++j) {
            if (j != i->second.begin()) {
                valf << " ";
            }
            valf << *j;
        }
        valf << endl;
    }

    return 0;
}
