#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cstdarg>
#include <cctype>

#define OUT argv[3]
#define HINT argv[2]
#define MAXLINE 1500

void ERR(const char *s, ...) {
    fprintf(stderr, "Error: ");
    va_list ap;
    va_start(ap, s);
    vfprintf(stderr, s, ap);
    va_end(ap);
    fprintf(stderr, "\n");
	fprintf(stdout, "%d\n", 0);
    exit(0);
}

void OK(int n, const char *s, ...) {
    va_list ap;
    va_start(ap, s);
    vfprintf(stderr, s, ap);
    va_end(ap);
    fprintf(stderr, "\n");
	fprintf(stdout, "%lf\n", n/100.0);
    exit(0);
}

int isvoid(char c) {
    return c == 0 || isspace(c);
}

char S['Z' - 'A' + 1];
char s1[MAXLINE];
char s2[MAXLINE];

int main(int argc, const char *argv[]) {
    FILE *hint = fopen(HINT, "rt");
    if (!hint)
        ERR("Viga vihjefaili avamisel");
    FILE *out = fopen(OUT, "rt");
    if (!out)
        OK(0, "Viga väljundfaili %s avamisel", OUT);
    for (int i = 0; fgets(s1, sizeof(s1), hint) != NULL; ++i) {
        if (fgets(s2, sizeof(s2), out) == NULL)
            OK(0, "Enneaegne väljundfaili lõpp");
        int j = 0;
        for ( ; !isvoid(s1[j]); ++j) {
            if (s1[j] >= 'A' && s1[j] <= 'Z') {
                if (s2[j] >= 'A' && s2[j] <= 'Z') {
                    if (S[s1[j] - 'A']) {
                        if (s2[j] != S[s1[j] - 'A'])
                            OK(0, "Mitmetooniline ala punktis %d %d", 1 + i, 1 + j);
                    } else {
                        S[s1[j] - 'A'] = s2[j];
                    }
                } else {
                    OK(0, "Lubamatu toon punktis %d %d", 1 + i, 1 + j);
                }
            } else if (s2[j] != s1[j]) {
                OK(0, "Rikutud taust punktis %d %d", 1 + i, 1 + j);
            }
        }
        for ( ; s2[j]; ++j) {
            if (!isvoid(s2[j]))
                OK(0, "Liigsed sümbolid rea %d lõpus", 1 + i);
        }
    }
    for (int c1 = 'A'; c1 <= 'Z'; ++c1) {
        for (int c2 = c1 + 1; c2 <= 'Z'; ++c2)
            if (S[c1 - 'A'] && S[c1 - 'A'] == S[c2 - 'A'])
                OK(0, "Korduvalt kasutatud toon %c", S[c1 - 'A']);
    }
    if (fscanf(out, "%10s", s2) > 0)
        OK(0, "Liigsed andmed väljundfaili lõpus");
    OK(100, "OK");
}
