# -*- coding: utf-8 -*-

# 2011-12-17 programmeerimisvõistlus
# Ülesanne: VENNK
# Autor: Karl-Aksel Puulmann
# Testitud: Python 2.7.2, Python 3.2.2

from collections import deque

def main():
    def laiuti_otsing(sr, sc, taide):
        queue = deque()
        queue.append((sr, sc))
        while queue:
            r, c = queue.pop()
            ## Jääb piiridesse? Pole varem märgitud?
            if 0 <= r < korgus and 0 <= c < laius and diagramm[r][c] == '.':
                diagramm[r][c] = taide
                queue.append((r-1, c))
                queue.append((r+1, c))
                queue.append((r, c-1))
                queue.append((r, c+1))

    sisend = open('s3sis.txt')
    laius, korgus = [int(x) for x in sisend.readline().split()]
    diagramm = []
    for _ in range(korgus):
        diagramm.append(list(sisend.readline().strip()))

    ## Iga rea kohta vaatame ainult äärisest "välja jäävaid asju"
    ## Probleemi taustaga lahendame järgneval moodusel:
    ## alustada iga rea ja veeru algusest laiuti otsingut suvalise
    ## märgiga ja hiljem märgid tagasi asendada
    for r in range(korgus):
        laiuti_otsing(r, 0, '+')
        laiuti_otsing(r, laius-1, '+')
    for c in range(laius):
        laiuti_otsing(0, c, '+')
        laiuti_otsing(korgus-1, c, '+')
    mitmes = 0
    for r in range(korgus):
        for c in range(laius):
            if diagramm[r][c] == '.':
                laiuti_otsing(r, c, chr(ord('A') + mitmes))
                mitmes += 1

    ## Taastame diagrammi,
    ## Teeme valjundi prinditavaks tekstiks ja väljastame faili
    valjund = '\n'.join(''.join(rida).replace('+','.') for rida in diagramm)
    open('s3val.txt','w').write(valjund)

main()
